-- name: [CS] Funky Kong
-- description: He's Finally Here! Funky Kong,\nthe best character in Mario Kart Wii\nis now in sm64coopdx!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
]]

local globalModName = "Funky Kong"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..globalModName.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_FUNKY_KONG = smlua_model_util_get_id("funky_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("funky_life") -- Located in "textures"
--local TEX_CUSTOM_STAR_ICON = get_texture_info("exclamation-icon") -- Located in "textures"

-- All Located in "sound"
local VOICETABLE_CHAR = {
	[CHAR_SOUND_ATTACKED] = { 'FUNKY_ATTACKED_2.ogg', 'FUNKY_ATTACKED_3.ogg'},
    [CHAR_SOUND_DOH] = 'VO_FK_WLE_FAIL.rwav.ogg',
    [CHAR_SOUND_DROWNING] = 'FUNKY_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'FUNKY_DYING.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'VO_FK_WLE2.rwav.ogg',
    [CHAR_SOUND_HAHA] = 'VO_FK_ITM_PWUP.rwav.ogg',
    [CHAR_SOUND_HAHA_2] = 'VO_FK_ITM_PWUP_END.rwav.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'se_grp_fnk#22.ogg',
    [CHAR_SOUND_HOOHOO] = 'FUNKY_HOOHOO.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'FUNKY_MAMA_MIA.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'FUNKY_OKEY_DOKEY.ogg',
    [CHAR_SOUND_ON_FIRE] = 'VO_FK_DMG_L2.rwav.ogg',
    [CHAR_SOUND_OOOF] = 'VO_FK_DMG_SPN_END.rwav.ogg',
    [CHAR_SOUND_OOOF2] = 'FUNKY_OOOF2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'FUNKY_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'VO_FK_ATK2.rwav.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'VO_FK_ATK.rwav.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'VO_FK_DSH.rwav.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'FUNKY_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'FUNKY_WAAAOOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'FUNKY_WAH2.ogg',
    [CHAR_SOUND_WHOA] = 'FUNKY_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'FUNKY_YAHOO.ogg',
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'FUNKY_TRIPLE_1.ogg','FUNKY_TRIPLE_2.ogg','FUNKY_TRIPLE_3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = 'FUNKY_YAH_WAH_HOO.ogg',
    [CHAR_SOUND_YAWNING] = 'FUNKY_YAWNING.ogg',
	[CHAR_SOUND_EEUH] = 'FUNKY_EEUH.ogg',
	--[CHAR_SOUND_COUGHING1] = 'COUGHING1.ogg',
	--[CHAR_SOUND_COUGHING2] = 'COUGHING2.ogg',
	--[CHAR_SOUND_COUGHING3] = 'COUGHING3.ogg',
	[CHAR_SOUND_UH] = 'FUNKY_UH.ogg',
	[CHAR_SOUND_UH2] = 'FUNKY_UH2.ogg',
	[CHAR_SOUND_UH2_2] = 'FUNKY_UH2_2.ogg',
	[CHAR_SOUND_PANTING] = 'FUNKY_PANTING.ogg',
	[CHAR_SOUND_PANTING_COLD] = 'FUNKY_PANTING.ogg',
	--[CHAR_SOUND_SNORING1] = 'SNORING.ogg',
	--[CHAR_SOUND_SNORING2] = 'SNORING2.ogg',
	--[CHAR_SOUND_SNORING3] = 'SNORING3.ogg',
	[CHAR_SOUND_HRMM] = 'FUNKY_HRMM.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'FUNKY_LETS_A_GO.ogg',
}

-- All Located in "actors"
--local CAPTABLE_CHAR = {
    --normal = smlua_model_util_get_id("custom_model_cap_normal_geo"),
    --wing = smlua_model_util_get_id("custom_model_cap_wing_geo"),
    --metal = smlua_model_util_get_id("custom_model_cap_metal_geo"),
    --metalWing = smlua_model_util_get_id("custom_model_cap_wing_geo"),
--}

--local E_MODEL_CUSTOM_STAR = smlua_model_util_get_id("custom_model_star_geo") -- Located in "actors"

local PALETTE_FUNKY_KONG = {
    [PANTS]  = "96afee",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "2e3134",
    [HAIR]   = "6c5000",
    [SKIN]   = "e5a369",
    [CAP]    = "b00000",
    [EMBLEM] = "ffffff"
}

--[[
-- All Located in "textures"
local healthMeter = {
    label = {
        left = get_texture_info("template-hp-back-left"),
        right = get_texture_info("template-hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("template-hp-pie-1"),
        [2] = get_texture_info("template-hp-pie-2"),
        [3] = get_texture_info("template-hp-pie-3"),
        [4] = get_texture_info("template-hp-pie-4"),
        [5] = get_texture_info("template-hp-pie-5"),
        [6] = get_texture_info("template-hp-pie-6"),
        [7] = get_texture_info("template-hp-pie-7"),
        [8] = get_texture_info("template-hp-pie-8"),
    }
}
]]

--[[
    Note: If there are some functionalities you don't care
    to add such as palettes, you can freely remove the function
    for it, the only function you require is character_add
]]

local CSloaded = false
local function on_character_select_load()
    CT_CHAR = _G.charSelect.character_add("Funky Kong", {"BANANA-SLAMA FLYING A PLANE", "", "Whoa, Dudes! My name's Funky Kong! My bodacious", "Jumbo Barrel can launch you to any point on the island!", "", "Funky Kong is a Kong who first appears in the ", "videogame 'Donkey Kong Country'. While portrayed", "as an easygoing surfer, Funky Kong is a very skilled", "mechanic, creating many vehicles and other", "inventions from limited materials, namely barrels."}, "Dee Kay, Ze_Boyy, Brob2nd", {r = 108, g = 80, b = 0}, E_MODEL_FUNKY_KONG, CT_WALUIGI, TEX_CUSTOM_LIFE_ICON)
    --_G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_MODEL_FUNKY_KONG, VOICETABLE_CHAR)
   --_G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_FUNKY_KONG, PALETTE_FUNKY_KONG)
    --_G.charSelect.character_add_health_meter(CT_CHAR, healthMeter)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
end

if _G.charSelect.credit_add then
    _G.charSelect.credit_add(globalModName, "Dee Kay", "Model, rigging, texturing")
    _G.charSelect.credit_add(globalModName, "Ze_Boyy", "Going through sounds, commisioner")
    _G.charSelect.credit_add(globalModName, "Brob2nd", "Recolorability")
end    
hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)